#include "deur.h"
#include <utility>
#include <iostream>

Deur::Deur(int x, int y, int lengte): x_coordinaat(x), y_coordinaat(y), lengte(lengte){

}

pair<int,int> Deur::coordinaten() const {
    pair<int,int> temp;
    temp.first=x_coordinaat;
    temp.second=y_coordinaat;
    return temp;
}

void Deur::open(){
    if(!sloten.empty()){
        for(std::list<Slot*>::iterator i = sloten.begin(); i != sloten.end(); ++i){
            if (!(*i)->isVergrendeld()){
                status = true;
            }
            else{
                status = false;
                return;
            }
        }
    }
    else status = true;
}

void Deur::sluit(){
    status = false;
    if(!sloten.empty()){
        for(std::list<Slot*>::iterator i = sloten.begin(); i != sloten.end(); ++i){
            (*i)->vergrendel();
        }
    }
}

bool Deur::isDeurOpen(){
    return status;
}

unsigned int Deur::deurLengte(){
    return lengte;
}

void Deur::addSlot(Slot *s){
    sloten.push_back(s);
}

Slot* Deur::geefSleutel(int i){
    std::list<Slot*>::iterator it = sloten.begin();
    advance(it, i);
    return *it;
}

std::list<Slot*> Deur::geefSlot(){
    return sloten;
}
